Unit AER12R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AER12R(NM :Integer; N :Integer; var A :Array of Real;
                var B :Array of Real; var DL :Array of Real;
                var IERR :Integer);

implementation

procedure AER12R(NM :Integer; N :Integer; var A :Array of Real;
                var B :Array of Real; var DL :Array of Real;
                var IERR :Integer);
var
I,J,K,I1,J1,NN :Integer;
X,Y :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15;
begin
IERR := 0;
NN := Abs(N);
if ( N < 0 ) 
 then goto _5;
{  ********** }
for I:=1 to N do
 begin
  I1 := I-1;

  for J:=I to N do
   begin
    X := B[(I-1)+(J-1)*NM];
    if ( I = 1 ) 
     then goto _2;

    for K:=1 to I1 do
     begin
_1:
      X := X-B[(I-1)+(K-1)*NM]*B[(J-1)+(K-1)*NM];
     end;

_2:
    if ( J <> I ) 
     then goto _3;
    if ( X <= 0.0 ) 
     then goto _14;
    Y := Sqrt(X);
    DL[I-1] := Y;
    goto _4;
_3:
    B[(J-1)+(I-1)*NM] := X/Y;
_4:
   end;
 end;
{  ********** }
_5:
for I:=1 to NN do
 begin
  I1 := I-1;
  Y := DL[I-1];

  for J:=I to NN do
   begin
    X := A[(I-1)+(J-1)*NM];
    if ( I = 1 ) 
     then goto _7;

    for K:=1 to I1 do
     begin
_6:
      X := X-B[(I-1)+(K-1)*NM]*A[(J-1)+(K-1)*NM];
     end;

_7:
    A[(J-1)+(I-1)*NM] := X/Y;
_8:
   end;
 end;
{  ********** }
for J:=1 to NN do
 begin
  J1 := J-1;

  for I:=J to NN do
   begin
    X := A[(I-1)+(J-1)*NM];
    if ( I = J ) 
     then goto _10;
    I1 := I-1;

    for K:=J to I1 do
     begin
_9:
      X := X-A[(K-1)+(J-1)*NM]*B[(I-1)+(K-1)*NM];
     end;

_10:
    if ( J = 1 ) 
     then goto _12;

    for K:=1 to J1 do
     begin
_11:
      X := X-A[(J-1)+(K-1)*NM]*B[(I-1)+(K-1)*NM];
     end;

_12:
    A[(I-1)+(J-1)*NM] := X/DL[I-1];
_13:
   end;
 end;

goto _15;
{  ********** }
_14:
IERR := 7*N+1;
_15:
end;

end.
